**********************************************************************
* PACKAGE LEIGEN  !" $BNO3X(B $B8GM-CM2r@O(B
*
*"  [HIS] 99/12/01(takepiro) SSL2 $B;HMQ(B
*
**********************************************************************
      SUBROUTINE LEIGEN
     M            ( AMAT   , 
     O              EIGVLR , EIGVLI ,
     O              EIGVCR , EIGVCI ,
     O              IERR   , 
     I              MATDIM , OEIVEC , NVEC  )
*
      IMPLICIT NONE
*
#include        "zcdim.F"                    !" 
#include        "zldim.F"                    !" $B78?t9TNs$NBg$-$5(B
*
*   [MODIFY] 
      REAL      AMAT  ( MATDMX, MATDMX )     !" $B78?t9TNs(B
*
*   [OUTPUT] 
      REAL      EIGVLR( MATDMX )             !" $B8GM-CM<B?tIt(B
      REAL      EIGVLI( MATDMX )             !" $B8GM-CM5u?tIt(B
      REAL      EIGVCR( MATDMX, * )          !" $B8GM-%Y%/%H%k<B?tIt(B
      REAL      EIGVCI( MATDMX, * )          !" $B8GM-%Y%/%H%k5u?tIt(B
      INTEGER   IERR                         !" $B%5%V%k!<%A%s%(%i!<%3!<%I(B
*
*   [INPUT] 
      INTEGER   MATDIM                       !" $B7W;;$9$k<!85(B
      LOGICAL   OEIVEC                       !" $B8GM-4X?t7W;;%9%$%C%A(B
      INTEGER   NVEC                         !" $B8GM-4X?t7W;;?t(B
*
*   [INTERNAL WORK] 
      COMMON    /COMWRK/  Z
*
      REAL      Z     ( MATDMX, MATDMX )     !" $B8GM-%Y%/%H%k(B
      REAL      WORK  ( MATDMX )             !" $B:n6HNN0h(B
*
      INTEGER   MODE                         !" $BJ?9U2=%9%$%C%A(B
      PARAMETER ( MODE = 0 )                 !" $BJ?9U2=$9$k(B
*
      CHARACTER HERR*8                       !" $B%(%i!<HV9f=PNOMQJ8;zJQ?t(B
      INTEGER   NERR                         !" $BJ8;zNs$ND9$5(B
      INTEGER   LENC                         !" $BJ8;z$ND9$5$rJV$94X?t(B
*
      SAVE      
*
*"  < 1. $B8GM-CM7W;;(B >
*
C      CALL CLCSTR( 'EIG1' )
*
#ifdef AUTO_DBL
      CALL DEIG1
#else
      CALL EIG1
#endif
     M     (  AMAT   , 
     O        MATDMX , MATDIM , MODE  , 
     O        EIGVLR , EIGVLI , 
     O        Z      , 
     W        WORK   , 
     O        IERR                     )
*
      IF ( IERR .NE. 0 ) THEN
         WRITE( HERR , '(I5)' ) IERR
         CALL CLADJ( HERR )
         NERR = LENC( HERR )
         CALL MSGDMP( 'W', 'LEIGEN', 
     &         'IERR = '//HERR(1:NERR)//' : EIGENVALUES NOT CORRECT ' )
      ENDIF
*
C      CALL CLCEND( 'EIG1' )
*
*"  < 2. $B8GM-%Y%/%H%k$NJB$SBX$((B > 
*
C      CALL CLCSTR( 'EIGSRT' )
*
      CALL EIGSRT
     M      (  EIGVLR , EIGVLI , 
     O         EIGVCR , EIGVCI ,
     I         Z      , 
     I         MATDIM , OEIVEC , NVEC  )
*
C      CALL CLCEND( 'EIGSRT' )
*
      RETURN
      END
************************************************************************
      SUBROUTINE EIGSRT      !" $B8GM-CM8GM-%Y%/%H%kJB$YJQ$((B
     M      (  EIGVLR , EIGVLI , 
     O         EIGVCR , EIGVCI , 
     I         Z      , 
     I         MATDIM , OEIVEC , NVEC  )
*
      IMPLICIT NONE
*
*   [PARA]
#include        "zcdim.F"                    !" 
#include        "zldim.F"                    !" $B78?t9TNs$NBg$-$5(B
*
*   [OUTPUT] 
      REAL      EIGVLR( MATDMX )             !" $B8GM-CM<B?tIt(B
      REAL      EIGVLI( MATDMX )             !" $B8GM-CM5u?tIt(B
      REAL      EIGVCR( MATDMX, * )          !" $B8GM-%Y%/%H%k<B?tIt(B
      REAL      EIGVCI( MATDMX, * )          !" $B8GM-%Y%/%H%k5u?tIt(B
*
*   [INPUT]
      REAL      Z     ( MATDMX, MATDMX )     !" $B8GM-%Y%/%H%k(B
*
      INTEGER   MATDIM                       !" $B7W;;$9$k<!85(B
      LOGICAL   OEIVEC                       !" $B8GM-4X?t7W;;%9%$%C%A(B
      INTEGER   NVEC                         !" $B8GM-4X?t7W;;?t(B
*
*   [INTERNAL WORK]
      INTEGER   J, K
      INTEGER   INDX  ( MATDMX )             !" $B=gHV3JG<G[Ns(B
      REAL      WORKR  ( MATDMX )            !" $B8GM-CMF~$l49$(MQG[Ns(B
      REAL      WORKI  ( MATDMX )            !" $B8GM-CMF~$l49$(MQG[Ns(B
*
*
*"  < 1. $B8GM-CM$N%=!<%H(B >
*
      CALL INDEXX                                   !" $B8GM-CM<B?tIt$N>.$5$$=g(B
     I       ( MATDIM , EIGVLR ,
     O         INDX              )
*
      CALL COPY( WORKR, EIGVLR, MATDIM )            !" $B8GM-CM<B?tIt(B
      CALL COPY( WORKI, EIGVLI, MATDIM )            !" $B8GM-CM5u?tIt(B
*
      DO 1100 K = 1, MATDIM                         !" $B8GM-CM<B?tIt$NBg$-$$=g(B
         EIGVLR( K ) = WORKR( INDX( MATDIM-K+1 ) )
         EIGVLI( K ) = WORKI( INDX( MATDIM-K+1 ) )
 1100 CONTINUE
*
      IF ( OEIVEC )THEN                 
         DO 2000 K = 1, NVEC                        !" $B8GM-CM<B?tIt$NBg$-$$=g(B
            IF ( EIGVLI(K) .EQ. 0.0 ) THEN
               DO 2100 J = 1, MATDIM
                  EIGVCR( J,K ) = Z( J,INDX(MATDIM-K+1)  )
                  EIGVCI( J,K ) = 0.
 2100          CONTINUE
*
            ELSE 
               IF (   ( WORKR( INDX(MATDIM-K+1) ) 
     &                    .EQ. WORKR( INDX(MATDIM-K+1)+1 ) )
     &               .AND.
     &                 ( WORKI( INDX(MATDIM-K+1) ) 
     &                    .EQ. -WORKI( INDX(MATDIM-K+1)+1 ) )  )THEN
                  DO 2200 J = 1, MATDIM
                     EIGVCR( J,K ) =  Z( J,INDX(MATDIM-K+1) ) 
                     EIGVCI( J,K ) =  Z( J,INDX(MATDIM-K+1)+1 )
 2200             CONTINUE
*
               ELSE
                  DO 2300 J = 1, MATDIM
                     EIGVCR(J,K) =    Z( J,INDX(MATDIM-K+1)-1 )
                     EIGVCI(J,K) =  - Z( J,INDX(MATDIM-K+1) )
 2300             CONTINUE
               ENDIF
            ENDIF
 2000    CONTINUE 
      ENDIF
*
      RETURN
      END
